package com.railway.web.controller.system;

import com.railway.common.annotation.Log;
import com.railway.common.core.controller.BaseController;
import com.railway.common.core.domain.AjaxResult;
import com.railway.common.core.domain.entity.SysRole;
import com.railway.common.core.domain.entity.SysUser;
import com.railway.common.core.page.TableDataInfo;
import com.railway.common.enums.BusinessType;
import com.railway.common.utils.StringUtils;
import com.railway.common.utils.poi.ExcelUtil;
import com.railway.system.service.ISysFileService;
import com.railway.system.service.ISysPostService;
import com.railway.system.service.ISysRoleService;
import com.railway.system.service.ISysUserService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import java.util.List;
import java.util.stream.Collectors;
import org.apache.commons.lang3.ArrayUtils;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

/**
 * 用户信息
 *
 * @author railway
 */
@Api(tags = "系统管理 - 用户管理")
@RestController
@RequestMapping("/system/user")
public class SysUserController extends BaseController {

  private final ISysUserService userService;
  private final ISysRoleService roleService;
  private final ISysPostService postService;
  private final ISysFileService sysFileService;

  public SysUserController(ISysUserService userService,
      ISysRoleService roleService, ISysPostService postService,
      ISysFileService sysFileService) {
    this.userService = userService;
    this.roleService = roleService;
    this.postService = postService;
    this.sysFileService = sysFileService;
  }

  /**
   * 获取用户列表
   */
  @ApiOperation(value = "用户列表", response = TableDataInfo.class)
  @PreAuthorize("@ss.hasPermi('system:user:list')")
  @GetMapping("/list")
  public TableDataInfo list(SysUser user) {
    startPage();
    List<SysUser> list = userService.selectUserList(user);
    return getDataTable(list);
  }

  @Log(title = "用户管理", businessType = BusinessType.EXPORT)
  @PreAuthorize("@ss.hasPermi('system:user:export')")
  @GetMapping("/export")
  public AjaxResult export(SysUser user) {
    List<SysUser> list = userService.selectUserList(user);
    ExcelUtil<SysUser> util = new ExcelUtil<>(SysUser.class);
    String localFilePath = util.exportExcel(list, "用户数据");
    return sysFileService.uploadFile(localFilePath);
  }

  @Log(title = "用户管理", businessType = BusinessType.IMPORT)
  @PreAuthorize("@ss.hasPermi('system:user:import')")
  @PostMapping("/importData")
  public AjaxResult importData(MultipartFile file, boolean updateSupport) throws Exception {
    ExcelUtil<SysUser> util = new ExcelUtil<>(SysUser.class);
    List<SysUser> userList = util.importExcel(file.getInputStream());
    String operName = getUsername();
    String message = userService.importUser(userList, updateSupport, operName);
    return AjaxResult.success(message);
  }

  @GetMapping("/importTemplate")
  public AjaxResult importTemplate() {
    ExcelUtil<SysUser> util = new ExcelUtil<>(SysUser.class);
    String localFilePath = util.importTemplateExcel("用户数据");
    return sysFileService.uploadFile(localFilePath);
  }

  /**
   * 根据用户编号获取详细信息
   */
  @ApiOperation(value = "根据用户编号获取详细信息", response = AjaxResult.class)
  @PreAuthorize("@ss.hasPermi('system:user:query')")
  @GetMapping(value = {"/", "/{userId}"})
  public AjaxResult getInfo(@PathVariable(value = "userId", required = false) Long userId) {
    userService.checkUserDataScope(userId);
    AjaxResult ajax = AjaxResult.success();
    List<SysRole> roles = roleService.selectRoleAll();
    ajax.put("roles", SysUser.isAdmin(userId) ? roles
        : roles.stream().filter(r -> !r.isAdmin()).collect(Collectors.toList()));
    ajax.put("posts", postService.selectPostAll());
    if (StringUtils.isNotNull(userId)) {
      SysUser sysUser = userService.selectUserById(userId);
      List<Long> roleIds = roleService.selectRoleListByUserId(userId);
      sysUser.setRoleIds(roleIds.toArray(new Long[0]));
      ajax.put(AjaxResult.DATA_TAG, sysUser);
      ajax.put("postIds", postService.selectPostListByUserId(userId));
      ajax.put("roleIds", roleIds);
    }
    return ajax;
  }

  /**
   * 新增用户
   */
  @ApiOperation(value = "新增用户", response = AjaxResult.class)
  @PreAuthorize("@ss.hasPermi('system:user:add')")
  @Log(title = "用户管理", businessType = BusinessType.INSERT)
  @PostMapping
  public AjaxResult add(@Validated @RequestBody SysUser user) {
    AjaxResult result = userService.checkUserUnique(user);
    if (StringUtils.isNotNull(result)) {
      return result;
    }
    user.setCreateBy(getUsername());
    return toAjax(userService.insertUser(user));
  }

  /**
   * 修改用户
   */
  @ApiOperation(value = "修改用户", response = AjaxResult.class)
  @PreAuthorize("@ss.hasPermi('system:user:edit')")
  @Log(title = "用户管理", businessType = BusinessType.UPDATE)
  @PutMapping
  public AjaxResult edit(@Validated @RequestBody SysUser user) {
    userService.checkUserAllowed(user);
    AjaxResult result = userService.checkUserUnique(user);
    if (StringUtils.isNotNull(result)) {
      return result;
    }
    user.setUpdateBy(getUsername());
    return toAjax(userService.updateUser(user));
  }

  /**
   * 删除用户
   */
  @ApiOperation(value = "删除用户", response = AjaxResult.class)
  @PreAuthorize("@ss.hasPermi('system:user:remove')")
  @Log(title = "用户管理", businessType = BusinessType.DELETE)
  @DeleteMapping("/{userIds}")
  public AjaxResult remove(@PathVariable Long[] userIds) {
    if (ArrayUtils.contains(userIds, getUserId())) {
      return error("当前用户不能删除");
    }
    return toAjax(userService.deleteUserByIds(userIds));
  }

  /**
   * 重置密码
   */
  @ApiOperation(value = "重置密码", response = AjaxResult.class)
  @PreAuthorize("@ss.hasPermi('system:user:resetPwd')")
  @Log(title = "用户管理", businessType = BusinessType.UPDATE)
  @PutMapping("/resetPwd")
  public AjaxResult resetPwd(@RequestBody SysUser user) {
    userService.checkUserAllowed(user);
    user.setUpdateBy(getUsername());
    return toAjax(userService.resetPwd(user));
  }

  /**
   * 状态修改
   */
  @ApiOperation(value = "状态修改", response = AjaxResult.class)
  @PreAuthorize("@ss.hasPermi('system:user:edit')")
  @Log(title = "用户管理", businessType = BusinessType.UPDATE)
  @PutMapping("/changeStatus")
  public AjaxResult changeStatus(@RequestBody SysUser user) {
    userService.checkUserAllowed(user);
    user.setUpdateBy(getUsername());
    return toAjax(userService.updateUserStatus(user));
  }

  /**
   * 根据用户编号获取授权角色
   */
  @ApiOperation(value = "根据用户编号获取授权角色", response = AjaxResult.class)
  @PreAuthorize("@ss.hasPermi('system:user:query')")
  @GetMapping("/authRole/{userId}")
  public AjaxResult authRole(@PathVariable("userId") Long userId) {
    AjaxResult ajax = AjaxResult.success();
    SysUser user = userService.selectUserById(userId);
    List<Long> roleIds = roleService.selectRoleListByUserId(userId);
    user.setRoleIds(roleIds.toArray(new Long[0]));
    List<SysRole> roles = roleService.selectRolesByUserId(userId);
    user.setRoles(roles);
    ajax.put("user", user);
    ajax.put("roles", SysUser.isAdmin(userId) ? roles
        : roles.stream().filter(r -> !r.isAdmin()).collect(Collectors.toList()));
    return ajax;
  }

  /**
   * 用户授权角色
   */
  @ApiOperation(value = "用户授权角色", response = AjaxResult.class)
  @PreAuthorize("@ss.hasPermi('system:user:edit')")
  @Log(title = "用户管理", businessType = BusinessType.GRANT)
  @PutMapping("/authRole")
  public AjaxResult insertAuthRole(Long userId, Long[] roleIds) {
    userService.insertUserAuth(userId, roleIds);
    return success();
  }
}
